/* Problem URL: https://codeforces.com/contest/2134/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        if (n == 1) {
            cout << "-1\n";
            continue;
        }

        vvi graph(n);

        rep(i, n - 1) {
            int a, b;
            cin >> a >> b;
            a--, b--;

            graph[a].push_back(b);
            graph[b].push_back(a);
        }

        vi parent(n);

        auto bfs = [&](int i) {
            const int inf = INT32_MAX >> 1;
            vi dis(n, inf);
            queue<int> q;

            dis[i] = 0;
            q.push(i);

            int ans = 0;

            while (!q.empty()) {
                i = q.front();
                q.pop();

                repv(j, graph[i]) {
                    if (dis[j] > dis[i] + 1) {
                        dis[j] = dis[i] + 1;
                        q.push(j);
                        ans = j;
                        parent[j] = i;
                    }
                }
            }

            return ans;
        };

        int end1 = bfs(0);
        fill(all(parent), -1);
        int end2 = bfs(end1);

        int a, b, c;
        int p = end2;
        int now = parent[end2];

        bool pos = false;

        while (parent[now] != -1 && !pos) {
            repv(j, graph[now]) {
                if (j == p || j == parent[now]) {
                    continue;
                }

                a = p;
                b = now;
                c = j;
                pos = true;
                break;
            }

            p = now;
            now = parent[now];
        }

        if (pos) {
            cout << a + 1 << ' ' << b + 1 << ' ' << c + 1 << '\n';
            continue;
        }

        cout << "-1\n";
    }
}
